from rest_framework_simplejwt.tokens import AccessToken
from django.contrib.auth import get_user_model
from ninja.security import HttpBearer
from ninja.errors import HttpError

User = get_user_model()


class TokenAuth(HttpBearer):
    def authenticate(self, request, token):
        try:
            access_token = AccessToken(token)
            user = User.objects.get(id=access_token["user_id"])
            return user
        except Exception:
            raise HttpError(401, "Invalid or expired token")
